/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// WhatsAppTemplateComponentType the model 'WhatsAppTemplateComponentType'
type WhatsAppTemplateComponentType string

// List of WhatsAppTemplateComponentType
const (
	WhatsAppTemplateComponentTypeHeader WhatsAppTemplateComponentType = "HEADER"
	WhatsAppTemplateComponentTypeBody WhatsAppTemplateComponentType = "BODY"
	WhatsAppTemplateComponentTypeFooter WhatsAppTemplateComponentType = "FOOTER"
	WhatsAppTemplateComponentTypeButtons WhatsAppTemplateComponentType = "BUTTONS"
	WhatsAppTemplateComponentTypeCarousel WhatsAppTemplateComponentType = "CAROUSEL"
)

// All allowed values of WhatsAppTemplateComponentType enum
var AllowedWhatsAppTemplateComponentTypeEnumValues = []WhatsAppTemplateComponentType{
	"HEADER",
	"BODY",
	"FOOTER",
	"BUTTONS",
	"CAROUSEL",
}

func (v *WhatsAppTemplateComponentType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WhatsAppTemplateComponentType(value)
	for _, existing := range AllowedWhatsAppTemplateComponentTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WhatsAppTemplateComponentType", value)
}

// NewWhatsAppTemplateComponentTypeFromValue returns a pointer to a valid WhatsAppTemplateComponentType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWhatsAppTemplateComponentTypeFromValue(v string) (*WhatsAppTemplateComponentType, error) {
	ev := WhatsAppTemplateComponentType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WhatsAppTemplateComponentType: valid values are %v", v, AllowedWhatsAppTemplateComponentTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WhatsAppTemplateComponentType) IsValid() bool {
	for _, existing := range AllowedWhatsAppTemplateComponentTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WhatsAppTemplateComponentType value
func (v WhatsAppTemplateComponentType) Ptr() *WhatsAppTemplateComponentType {
	return &v
}

type NullableWhatsAppTemplateComponentType struct {
	value *WhatsAppTemplateComponentType
	isSet bool
}

func (v NullableWhatsAppTemplateComponentType) Get() *WhatsAppTemplateComponentType {
	return v.value
}

func (v *NullableWhatsAppTemplateComponentType) Set(val *WhatsAppTemplateComponentType) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateComponentType) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateComponentType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateComponentType(val *WhatsAppTemplateComponentType) *NullableWhatsAppTemplateComponentType {
	return &NullableWhatsAppTemplateComponentType{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateComponentType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateComponentType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

